//+------------------------------------------------------------------+
//|                                             Volatility.Pivot.mq4 |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//
#property copyright "thanks to S.B.T. (Japan)"
#property link      "http://sufx.core.t3-ism.net/" //<<< convert this from VT, thanks mate !!!
//+------------------------------------------------------------------+
//|                                                                  |
//| 2008 Added Speech. ( Speech.tpl ) Rev.2 ( itemsdepot@hotmail.com)|
//|                                                                  |
//+------------------------------------------------------------------+
//----------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Orange
#property indicator_width1 5
#property indicator_width2 7
//---- input parameters
extern bool       VPDrawPivotLine=True;
extern bool       VPDrawPivotPoint=True;
extern double     VPatr_range=100.0;
extern double     VPima_range = 10;
extern double     VPatr_factor=3;
extern int        VPMode = 0;
extern double     VPDeltaPrice = 30;
extern int        VPDataSamplingRange=300;  
extern int        VPDrawRange=250;
extern bool       VPAlertBox=False;
extern bool       VPAudioAlert=False;
extern string     VPWaveFileName="pivotpoint.wav";
extern double     VPAlarmDelay=27.0;
extern double     VPCounter=0;



//---- buffers
double TrStop[];
double ATR[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
   //---- indicators
   IndicatorShortName("!! RisenbergVolatilityCapture R1");

   if (VPDrawPivotLine) SetIndexStyle(0,0,0,indicator_width1,indicator_color1); 
    else SetIndexStyle(0,12,0,indicator_width1,indicator_color1);
   SetIndexBuffer(0, TrStop);
     
   if (VPDrawPivotPoint) SetIndexStyle(1,0,0,indicator_width2,indicator_color2); 
    else SetIndexStyle(1,12,0,indicator_width2,indicator_color2);   
   SetIndexBuffer(1, ATR);
   SetIndexLabel(1,"range base");   
   
   
   VPCounter=TimeCurrent();
   //VPAlarmDelay=7;
   //----
   return(0);
  }
  
  
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+

  int deinit()
  {   
   //----
   return(0);
  }
  
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+


int start()
  {
   int counted_bars = IndicatorCounted();
   int limit;
   int i;
   int SamplingModeType=0;    // 0 ema 1-sma dah
   double FinishTime=TimeCurrent();  
   double DeltaStop;
   
   //limit = Bars;
   //int position=Bars-counted_bars;   
   //if ( position < 0 ) position=0;
   //if ( position > 500 ) position = 720;   // display range limit dah
   
   //-------------------------------------
   for(i = VPDataSamplingRange; i >=0 ; i --) 
   {
      ATR[i] = iATR(NULL,0,VPatr_range,i);
   }
   
   
   //-------------------------------------
   for(i = VPDrawRange; i >= 0; i --) 
   {
      //--------------------------
      if (VPMode == 0) {
         DeltaStop = iMAOnArray(ATR,0,VPima_range,0,MODE_EMA,i) * VPatr_factor;
         //Print(DeltaStop);
         //DeltaStop = iATR(NULL,0,atr_range,i) * atr_factor;
      } else {
         DeltaStop = VPDeltaPrice*Point;
      }
      
      
      
      
      //---------------------------
      if ( Close[i] == TrStop[i + 1]) 
      {
         TrStop[i] = TrStop[i + 1];
         //ATR[i] = iATR(NULL,0,atr_range,i);
      } 
      else 
      {
         if ( Close[i+1] < TrStop[i+1] && Close[i]<TrStop[i+1]) 
         {
               TrStop[i] = MathMin(TrStop[i + 1], Close[i] + DeltaStop);
               //ATR[i] = Close[i] - (iATR(NULL,0,atr_range,i));
         } 
         else 
         {
            if ( Close[i+1] > TrStop[i+1] && Close[i]>TrStop[i+1]) 
            {
               TrStop[i] = MathMax(TrStop[i + 1], Close[i] - DeltaStop);
               ATR[i] = Low[i] - (iATR(NULL,0,VPatr_range,i));         
            } 
            else 
            {
               FinishTime=TimeCurrent();
               if ( FinishTime - VPCounter > VPAlarmDelay )   //---   && i==0)
               {
                    if ( VPAlertBox ) Alert("V.PivotR1 Cross at Candle: "+i+"  Price: "+Close[i]);
                    if ( VPAudioAlert ) PlaySound(VPWaveFileName);
                    VPCounter=FinishTime;
               }
            
               
                              
               if ( Close[i] > TrStop[i+1])
               {
                TrStop[i] = Close[i] - DeltaStop;
                ATR[i] = Low[i] - (iATR(NULL,0,VPatr_range,i));
               } 
               else
               {
                TrStop[i] = Close[i] + DeltaStop;
                ATR[i] = Low[i] - (iATR(NULL,0,VPatr_range,i));
                //-----------------
               }
            }
         }
      }
   }

   //----
   double finishTime=GetTickCount();   //WindowRedraw();

   return(0);
  }
//+------------------------------------------------------------------+













///----------------